.\" {PTM/PB/0.2/01-06-1999/"Drukuj tras pakietw"}
.\" Translation (c) 1999 Przemek Borys <pborys@dione.ids.pl>
.\" Copyright (c) 1990, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" This code is derived from software contributed to Berkeley by
.\" Van Jacobson.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)traceroute.8	8.1 (Berkeley) 6/6/93
.\"
.Dd 6 Czerwiec, 1993
.Dt TRACEROUTE 8
.Os BSD 4.3
.Sh NAZWA
.Nm traceroute
.Nd drukuj tras, ktr przebiegaj pakiety do hosta sieciowego
.Sh SKADNIA
.Nm traceroute
.Op Fl m Ar max_ttl
.Op Fl n
.Op Fl p Ar port
.Op Fl q Ar nqueries
.Op Fl r
.Bk -words
.Op Fl s Ar src_addr
.Ek
.Op Fl t Ar tos
.Op Fl w Ar waittime
.Ar host
.Op Ar packetsize
.Sh OPIS
Internet jest wielk i skomplikowan agregacj sprztu sieciowego,
poczonego ze sob poprzez bramki (gateways). ledzenie trasy, ktr
podaj pakiety danej osoby (lub znajdywanie paskudnej bramki, odrzucajcej
twoje pakiety) moe by trudne.
.Nm Traceroute
wykorzystuje pole `time to live' protokou IP i prbuje wydoby odpowied
.Tn ICMP
.Dv TIME_EXCEEDED
od kadej bramki na drodze do okrelonego hosta.
.Pp
Jedynym wymaganym parametrem jest nazwa hosta docelowego lub jego IP.
Domylny prbny datagram ma dugo 38 bajtw, lecz moe to by zwikszone
przez podanie rozmiaru pakietu za nazw hosta docelowego.
.Pp
Inne opcje to:
.Bl -tag -width Ds
.It Fl m Ar max_ttl
Ustaw maksymalny time-to-live (ttl - `czas ycia' maksymalna liczba
skokw - hops) uywany w wychodzcych pakietach prbnych. Domylnie uywa si
wartoci 30 (podobnie jak dla pocze
.Tn TCP
).
.It Fl n
Drukuj adresy skokw (hops) numerycznie zamiast symbolicznie i numerycznie
(oszczdza szukania w DNS skojarzenia adres-nazwa dla kadej napotkanej
po drodze bramki).
.It Fl p Ar port
Ustaw podstawowy numer
.Ar portu
.Tn UDP
uywanego w prbkach (domylnie 33434).
.Nm Traceroute
ma nadziej, e nic nie nasuchuje na portach 
.Tn UDP
od
.Em base
do
.Em base+nhops-1
na hocie docelowym (tak, e zwracany bdzie komunikat
.Tn ICMP
.Dv PORT_UNREACHABLE
, koczcy ledzenie trasy). Jeli co nasuchuje na porcie w domylnym
zakresie, opcja ta moe by uyta do wybrania nieuywanego zakresu.
.It Fl q Ar nqueries
Ustaw liczb prb na kade `ttl' na
.Ar nqueries
(domylnie trzy prby).
.It Fl r
Obejd normalne tablice trasowania (routingu) i wysyaj bezporednio do
hosta w przyczonej sieci.
Jeli host nie znajduje si w bezporednio przyczonej sieci, zwracany jest
bd.
Opcja ta moe by uyta do pingowania hosta lokalnego poprzez interfejs,
ktry nie ma przez siebie adnej trasy (route) (np. po porzuceniu interfejsu
przez
.Xr routed 8 ) .
.It Fl s Ar src_addr
Uywaj zadanego adresu IP (ktry musi by podany jako numer IP, nie
nazwa hosta) jako adresu rdowego w wychodzcych pakietach prbnych. Na
hostach z wicej ni jednym adresem IP, opcja ta moe by uywana do
wymuszania adresu rdowego innego ni adres IP interfejsu, na ktrym
posyana jest prbka. Jeli adres IP nie jest jednym z tych adresw
interfejsowych maszyny, zwracany jest bd i nic nie jest wysyane.
.It Fl t Ar tos
Ustaw
.Em type-of-service
(rodzaj usugi) w pakietach prbnych na zadan warto (domylnie
zero). Warto musi by dziesitn liczb cakowit z zakresu 0 do 255.
Opcja ta moe by uywana do sprawdzania czy rne rodzaje usug powoduj
rne cieki (jeli nie pracujesz z systemem
.Bx 4.3 Tahoe
lub pniejszym, moe to by czysto akademickie, poniewa normalne
usugi sieciowe, takie jak telnet i ftp nie pozwol ci kontrolowa
.Dv TOS ) .
Nie wszystkie wartoci
.Dv TOS
s dozwolone lub maj znaczenie
\- zobacz specyfikacj IP. Uytecznymi wartociami s prawdopodobnie
.Ql \-t 16
(low delay) (mae opnienie) i
.Ql \-t 8
(high throughput) (duy przepyw).
.It Fl v
Interaktywne wyjcie. Listowane s odebrane pakiety
.Tn ICMP
inne ni
.Dv TIME_EXCEEDED
i
.Dv UNREACHABLE Ns s .
.It Fl w
Ustaw czas (w sekundach) oczekiwania na odpowied na prbk (domylnie 3
sekundy).
.El
.Pp
Program ten prbuje ledzi tras pakietw IP, ktr taki pakiet przebyby
do danego hosta internetowego. Czyni to odpalajc prbki
.Tn UDP
z maym ttl (time to live), a nastpnie nasuchujc od bramki odpowiedzi
.Tn ICMP
"time exceeded". Rozpoczynamy prbki z ttl wartoci jeden i
zwikszamy je, a otrzymamy odpowied
.Tn ICMP
"port unreachable"
(co znaczy, e dostalimy si do "hosta") lub doszlimy do maksimum (co
domylnie odpowiada 30 skokom i moe by zmienione flag
.Fl m
).  Dla kadego ttl wysyane s trzy prbki (zmieniane flag
.Fl q
), czego efektem jest wypisanie linijki, pokazujcej ttl, adres bramki i
zaokrglony czas podry kadej z prbek. Jeli odpowiedzi prbek przyszy
z rnych bramek, wydrukowane zostan adresy wszystkich odpowiadajcych
systemw.
Jeli nie byo odpowiedzi podczas 3 sekundowego interwau (okrelanego jako
`timeout' i zmienianego flag
.Fl w
), to dla danej prbki drukowane jest "*".
.Pp
Nie chcemy, by docelowy host przetwarza prbki pakietw
.Tn UDP
, wic docelowy port jest ustawiany na warto niespotykan (jeli
jaki prostak na hocie docelowym uywa jednak tej wartoci, mona j zmieni
flag
.Fl p
).
.Pp
Przykadem uycia i wyjcia moe by:
.Bd -literal
[yak 71]% traceroute nis.nsf.net.
traceroute to nis.nsf.net (35.1.1.48), 30 hops max, 56 byte packet
1  helios.ee.lbl.gov (128.3.112.1)  19 ms  19 ms  0 ms
2  lilac-dmc.Berkeley.EDU (128.32.216.1)  39 ms  39 ms  19 ms
3  lilac-dmc.Berkeley.EDU (128.32.216.1)  39 ms  39 ms  19 ms
4  ccngw-ner-cc.Berkeley.EDU (128.32.136.23)  39 ms  40 ms  39 ms
5  ccn-nerif22.Berkeley.EDU (128.32.168.22)  39 ms  39 ms  39 ms
6  128.32.197.4 (128.32.197.4)  40 ms  59 ms  59 ms
7  131.119.2.5 (131.119.2.5)  59 ms  59 ms  59 ms
8  129.140.70.13 (129.140.70.13)  99 ms  99 ms  80 ms
9  129.140.71.6 (129.140.71.6)  139 ms  239 ms  319 ms
10  129.140.81.7 (129.140.81.7)  220 ms  199 ms  199 ms
11  nic.merit.edu (35.1.1.48)  239 ms  239 ms  239 ms

.Ed
Zauwa, e linie 2 i 3 s takie same. Stao si to z powodu zapluskwionego
jdra na systemie odwiedzonym w drugim skoku \- lbl-csam.arpa, ktre
przekazuje pakiety o zerowym ttl (bd w rozpowszechnianej wersji
.Tn BSD 4.3
).
Zauwa, e musisz zgadywa, ktr konkretnie ciek obieraj pakiety,
poniewa
.Tn NSFNet
(129.140)
nie dostarcza translacji adres-na-nazw dla swoich
.Tn NSS Ns w .
.Pp
Ciekawszym przykadem jest:
.Bd -literal
[yak 72]% traceroute allspice.lcs.mit.edu.
traceroute to allspice.lcs.mit.edu (18.26.0.115), 30 hops max
1  helios.ee.lbl.gov (128.3.112.1)  0 ms  0 ms  0 ms
2  lilac-dmc.Berkeley.EDU (128.32.216.1)  19 ms  19 ms  19 ms
3  lilac-dmc.Berkeley.EDU (128.32.216.1)  39 ms  19 ms  19 ms
4  ccngw-ner-cc.Berkeley.EDU (128.32.136.23)  19 ms  39 ms  39 ms
5  ccn-nerif22.Berkeley.EDU (128.32.168.22)  20 ms  39 ms  39 ms
6  128.32.197.4 (128.32.197.4)  59 ms  119 ms  39 ms
7  131.119.2.5 (131.119.2.5)  59 ms  59 ms  39 ms
8  129.140.70.13 (129.140.70.13)  80 ms  79 ms  99 ms
9  129.140.71.6 (129.140.71.6)  139 ms  139 ms  159 ms
10  129.140.81.7 (129.140.81.7)  199 ms  180 ms  300 ms
11  129.140.72.17 (129.140.72.17)  300 ms  239 ms  239 ms
12  * * *
13  128.121.54.72 (128.121.54.72)  259 ms  499 ms  279 ms
14  * * *
15  * * *
16  * * *
17  * * *
18  ALLSPICE.LCS.MIT.EDU (18.26.0.115)  339 ms  279 ms  279 ms

.Ed
Zauwa, e bramki 12, 14, 15, 16 i 17 albo nie przesyaj komunikatw
.Tn ICMP
"time exceeded" lub przesyaj je z ttl zbyt maym by nas osign. 14 \- 17
pracuj pod kontrol kodu 
.Tn MIT
C Gateway, ktry nie wysya "time exceeded"s. Bg jeden wie, co dzieje
si na 12.
.Pp
Cicha bramka 12 w powyszym moe by wynikiem bdu w kodzie sieciowym 4.[23]
.Tn BSD
(i jego pochodnych): 4.x (x <= 3) wysya nieosigalne komunikaty, uywajc
ttl pozostaego w oryginalnych datagramach. Zatem, dla bramek, pozostay
ttl wynosi zero,
.Tn ICMP
"time exceeded" nie ma szans doj z powrotem do nas. Zachowanie tego bdu
jest troch ciekawsze kiedy pojawi si na systemie docelowym:
.Bd -literal
1  helios.ee.lbl.gov (128.3.112.1)  0 ms  0 ms  0 ms
2  lilac-dmc.Berkeley.EDU (128.32.216.1)  39 ms  19 ms  39 ms
3  lilac-dmc.Berkeley.EDU (128.32.216.1)  19 ms  39 ms  19 ms
4  ccngw-ner-cc.Berkeley.EDU (128.32.136.23)  39 ms  40 ms  19 ms
5  ccn-nerif35.Berkeley.EDU (128.32.168.35)  39 ms  39 ms  39 ms
6  csgw.Berkeley.EDU (128.32.133.254)  39 ms  59 ms  39 ms
7  * * *
8  * * *
9  * * *
10  * * *
11  * * *
12  * * *
13  rip.Berkeley.EDU (128.32.131.22)  59 ms !  39 ms !  39 ms !

.Ed
Zauwa, e jest tu 12 bramek (13 jest ostatecznym celem), a dokadnie
ostatniej poowy listy "brakuje". Co naprawd si dzieje to to, e
rip (Sun-3 pracujcy pod Sun OS3.5) uywa ttl z naszych przychodzcych
datagramw jako ttl w swoich odpowiedziach
.Tn ICMP.
Tak wic odpowied nie dojdzie, bo przekroczy zadany czas (timeout) na drodze
powrotnej (bez wysyania ostrzee do kogokolwiek, bo dla ICMP nie s
wysyane ICMP).
Zmieni si to, gdy uyjemy ttl o dugoci co najmniej dwa razy wikszej ni
dugo cieki. Np. rip jest w rzeczywistoci odlegy tylko o 7 skokw.
Odpowied, ktra wraca z ttl o wartoci 1 jest ladem, e
istnieje taki problem. Gdy ttl jest <=1
.Nm Traceroute
za czasem podry pakietu drukuje dodatkowo znak
.Sy ! .
Poniewa dystrybutorzy sprzedaj sporo oprogramowania przestarzaego
.Pf ( Tn DEC Ns \'s
Ultrix, Sun 3.x) lub
niestandardowego
.Pq Tn HPUX
, oczekuj e moesz spotka ten problem czsto i uwaaj, wybierajc host
docelowy twoich prbek. Innymi moliwymi adnotacjami, wystpujcymi po
wydrukowanym czasie, s
.Sy !H ,
.Sy !N ,
.Sy !P
(otrzymaem niedostpno hosta, sieci (network) lub protokou),
.Sy !S
lub
.Sy !F
(zawioda trasa rda lub niezbdna jest fragmentacja \- adne z
tych nie powinno nigdy si pojawi). Jeli prawie wszystkie prbki dadz
w wyniku jaki rodzaj nieosigalnoci,
.Nm traceroute
podda si i wyjdzie.
.Pp
Program ten jest przeznaczony do stosowania w testowaniu, pomiarach i
zarzdzaniu sieci. Powinien by uywany gwnie do rcznego izolowania
bdw.
Nie zaleca si wykorzystywania traceroute w automatach (skryptach),
gdy powoduje on due obcienie sieci.
.Sh AUTOR
Zaimplementowane przez Vana Jacobsona wg pomysu Steve Deering.
Na wyrnienie zasuguje Philip Wood, Tim Seaver i Ken Adelman.
.Sh ZOBACZ TAKE
.Xr netstat 1 ,
.Xr ping 8
.Sh HISTORIA
Komenda
.Nm
jest obecnie w testach.
